<meta content="text/html; charset=UTF-8" http-equiv="Content-Type">
<meta name="keywords" content="disk encryption, security, transparent, AES, plausible deniability, virtual drive, Linux, MS Windows, portable, USB drive, partition">
<meta name="description" content="LibreCrypt: An Open-Source transparent encryption program for PCs. With this software, you can create one or more &quot;containers&quot; on your PC - which appear as disks, anything written to these disks is automatically encrypted before being stored on your hard drive.">

<meta name="author" content="Sarah Dean">
<meta name="copyright" content="Copyright 2004, 2005, 2006, 2007, 2008 Sarah Dean 2015 tdk">

<TITLE>Command Line Interface</TITLE>

<link href="https://raw.githubusercontent.com/t-d-k/librecrypt/master/docs/styles_common.css" rel="stylesheet" type="text/css">


<link rel="shortcut icon" href="https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox.ico" type="image/x-icon">

<SPAN CLASS="master_link">
[![LibreCrypt logo](https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox128.png)](http://LibreCrypt.eu/)
</SPAN>

<SPAN CLASS="master_title">
_[LibreCrypt](http://LibreCrypt.eu/): Open-Source disk encryption for Windows_
</SPAN>
***

<SPAN class="tip">
The latest version of this document can be found at the [LibreCrypt project site](https://github.com/t-d-k/librecrypt)
</SPAN>

## Read the [getting started](getting_started.md) guide first.

## Documentation Index                               
                                                              
* [advanced topics](advanced_topics.md)
* [command line](command_line.md)
* [command line decryption utilities](command_line_decryption_utilities.md)
* [contact details](contact_details.md)
* [contents](contents.md)
* [credits](credits.md)
* [description](description.md)
* [download](download.md)
* [FAQ](FAQ.md)
* [fault reporting](fault_reporting.md)
* [getting started](getting_started.md)
* [glossary](glossary.md)
* [impact of kernel driver signing](impact_of_kernel_driver_signing.md)
* [index](index.md)
* [installation and upgrading](installation_and_upgrading.md)
* [installation and upgrading - PC](installation_and_upgrading__PC.md)
* [known bugs](known_bugs.md)
* [licence](licence.md)
* [Linux examples - cryptoloop](Linux_examples__cryptoloop.md)
* [Linux examples - dm-crypt](Linux_examples__dm-crypt.md)
* [Linux examples - LUKS](Linux_examples__LUKS.md)
* [Linux containers](Linux_volumes.md)
* [notes](notes.md)
* [notes PC](notes_PC.md)
* [pkcs11 drivers](pkcs11_drivers.md)
* [pkcs11 support](pkcs11_support.md)
* [plausible deniability](plausible_deniability.md)
* [portable mode](portable_mode.md)
* [technical details](technical_details.md)
* [technical details - build notes](technical_details__build_notes.md)
* [technical details - creating a new hash cypher driver](technical_details__creating_a_new_hash_cypher_driver.md)
* [technical details - creating FreeOTFE containers](technical_details__creating_FreeOTFE_volumes.md)
* [technical details - filename extensions](technical_details__filename_extensions.md)
* [technical details - FreeOTFE CDB layout](technical_details__FreeOTFE_CDB_layout.md)
* [technical details - FreeOTFE CDB layout format 1](technical_details__FreeOTFE_CDB_layout_format_1.md)
* [technical details - FreeOTFE CDB layout format 2](technical_details__FreeOTFE_CDB_layout_format_2.md)
* [technical details - FreeOTFE CDB layout format 3](technical_details__FreeOTFE_CDB_layout_format_3.md)
* [technical details - FreeOTFE CDB layout format 4](technical_details__FreeOTFE_CDB_layout_format_4.md)
* [technical details - FreeOTFE CDB layout format 5](technical_details__FreeOTFE_CDB_layout_format_5.md)
* [technical details - FreeOTFE containers and keyfiles](technical_details__FreeOTFE_volumes_and_keyfiles.md)
* [technical details - opening FreeOTFE containers](technical_details__mounting_FreeOTFE_volumes.md)
* [technical details - partition encryption decryption](technical_details__partition_encryption_decryption.md)
* [technical details - registry entries](technical_details__registry_entries.md)
* [technical details - RNGs](technical_details__RNGs.md)
* [TODO list](TODO_list.md)
* [translations](translations.md)
* [uninstalling](uninstalling.md)
* [version history](version_history.md)
                                                          



























































