<meta content="text/html; charset=UTF-8" http-equiv="Content-Type">
<meta name="keywords" content="disk encryption, security, transparent, AES, plausible deniability, virtual drive, Linux, MS Windows, portable, USB drive, partition">
<meta name="description" content="LibreCrypt: An Open-Source transparent encryption program for PCs. With this software, you can create one or more &quot;containers&quot; on your PC - which appear as disks, anything written to these disks is automatically encrypted before being stored on your hard drive.">

<meta name="author" content="Sarah Dean">
<meta name="copyright" content="Copyright 2004, 2005, 2006, 2007, 2008 Sarah Dean 2015 tdk">


<TITLE>Technical Details</TITLE>

<link href="https://raw.githubusercontent.com/t-d-k/librecrypt/master/docs/styles_common.css" rel="stylesheet" type="text/css">


<link rel="shortcut icon" href="https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox.ico" type="image/x-icon">

<SPAN CLASS="master_link">
[![LibreCrypt logo](https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox128.png)](http://LibreCrypt.eu/)
</SPAN>
<SPAN CLASS="master_title">
_[LibreCrypt](http://LibreCrypt.eu/): Open-Source disk encryption for Windows_
</SPAN>
***
<SPAN class="tip">
The latest version of this document can be found at the [LibreCrypt project site](https://github.com/t-d-k/librecrypt)
</SPAN>   

## Technical Details

Please select from the following sections:


* [Volumes and Keyfiles](technical_details__FreeOTFE_volumes_and_keyfiles.md)
* [Critical Data Block (CDB) Layouts](technical_details__FreeOTFE_CDB_layout.md)

	* [CDB Format ID 1](technical_details__FreeOTFE_CDB_layout_format_1.md) _(obsolete)_
	* [CDB Format ID 2](technical_details__FreeOTFE_CDB_layout_format_2.md) _(obsolete)_
	* [CDB Format ID 3](technical_details__FreeOTFE_CDB_layout_format_3.md) _(obsolete)_
	* [CDB Format ID 4](technical_details__FreeOTFE_CDB_layout_format_4.md)

* [Creating Volumes](technical_details__creating_FreeOTFE_volumes.md)
* [Mounting Volumes](technical_details__mounting_FreeOTFE_volumes.md)
* [Encrypted Partition Encryption/Decryption](technical_details__partition_encryption_decryption.md)
* [Registry Entries](technical_details__registry_entries.md)
* [Random Number Generators (RNGs)](technical_details__RNGs.md)
* [Building the Software](technical_details__build_notes.md)
* [Creating a New Hash/Cypher Driver](technical_details__creating_a_new_hash_cypher_driver.md)
* [Filename Extensions](technical_details__filename_extensions.md)


